/***********************************************************************/
/*                                                                     */
/*  FILE        :H8_USB1_C.c                                           */
/*  DATE        :Thu, Sep 21, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3694F                                              */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.5).     */
/*                                                                     */
/***********************************************************************/
/*
;	H8USB1_C.c		2006-09-29
;
;	H8/3694-USB demo1
;
;	CPU:	H8/3694F (20MHz)
;
;				c[H[
;					M.Ohta
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
*/



#include <machine.h>
#include "iodefine.h"

#ifdef __cplusplus
extern "C" {
void abort(void);
#endif
void main(void);
#ifdef __cplusplus
}
#endif


volatile unsigned char HEX_H;
volatile unsigned char HEX_L;
volatile unsigned int PERIOD;
volatile unsigned int WIDTH;
volatile unsigned int RX_POINTER;
volatile unsigned char CR_FLAG;
volatile unsigned char I2CBUF[32];
volatile unsigned char RXBUF[64];




void TX1RS(unsigned char TX_data);




void Timer(int Time){						//Time(mSec)

int i,j;

	for(j=0; j<Time; j++){
		for(i=0; i<3500; i++){
		}
	}
}



unsigned char HEX_BIN(unsigned char hex){
	if(hex > 0x39){return ((hex & 0x0f)+9);}
	else{return (hex & 0x0f);}
}



unsigned char HEX2_BIN(unsigned char *p){

unsigned char hi,lo;

	hi = HEX_BIN(*p);
	p +=1;
	lo = HEX_BIN(*p);
	return hi*16 + lo;

}




unsigned int HEX4_BIN(unsigned char *p){

unsigned char hh,hl,lh,ll;

	hh = HEX_BIN(*p);
	p +=1;
	hl = HEX_BIN(*p);
	p +=1;
	lh = HEX_BIN(*p);
	p +=1;
	ll = HEX_BIN(*p);
	p +=1;

	return hh*4096 + hl*256 + lh*16 + ll;

}



unsigned char HEX2_BCD(unsigned char *p){

unsigned char hi,lo;

	hi = *p & 0x0f;
	p += 1;
	lo = *p & 0x0f;

	return hi*16 + lo;
	
} 




void BIN_HEX(unsigned char bin){			//binHEX_H,HEX_L

unsigned char dummy;

	dummy = (bin/16) & 0x0f;
	if(dummy > 9){HEX_H = dummy + 0x37;}
	else{HEX_H = dummy | 0x30;}

	dummy = bin & 0x0f;
	if(dummy > 9){HEX_L = dummy + 0x37;}
	else{HEX_L = dummy | 0x30;}
	
}
	
	 

void TX1HEX(unsigned char bin){

	BIN_HEX(bin);
	TX1RS(HEX_H);
	TX1RS(HEX_L);
}



void TX2HEX(unsigned int word){

unsigned char dummy;

	dummy = word/256;
	BIN_HEX(dummy);
	TX1RS(HEX_H);
	TX1RS(HEX_L);

	dummy = word & 0xff;
	BIN_HEX(dummy);
	TX1RS(HEX_H);
	TX1RS(HEX_L);
}









void AD_START(void){						//A/D trig.

	AD.ADCSR.BIT.ADST = 1;
	while(AD.ADCSR.BIT.ADF == 0){
	}
	AD.ADCSR.BIT.ADST = 0;
	AD.ADCSR.BIT.ADF = 0;
}



void TX1RS(unsigned char TX_data){			//TX 1data to PC

	while(SCI3.SSR.BIT.TDRE == 0){}
	SCI3.TDR = TX_data;
}



void RXBUF_CLR(void){

	RXBUF[0] = 0;
	RXBUF[1] = 0;
	CR_FLAG = 0;
	RX_POINTER = 0;
}




void RTC_RD(void){							//read RTC

unsigned int i;
unsigned char dummy;

	for(i=0; i<32; i++){I2CBUF[i] = 0;}		//clear I2CBUF
	if((IO.PDR5.BYTE & 0xc0) != 0xc0){return;}		//P56,P57 Dip SW off ?


	while(IIC2.ICCR2.BIT.BBSY != 0){}		//Wait for I2CBUS ready
	IIC2.ICCR1.BYTE |= 0x30;				//MST=1,TRS=1 (Master TX mode)
	dummy = IIC2.ICCR2.BYTE & 0x3f;
	IIC2.ICCR2.BYTE = dummy | 0x80;			//BBSY=1,SCP=0(Jn)
	IIC2.ICDRT = 0xa2;						//TX SLA+W(0)
	while(IIC2.ICSR.BIT.TEND == 0){}		//Wait for TEND
	if(IIC2.ICIER.BIT.ACKBR != 0){goto RTC_NG;}

	IIC2.ICDRT = 2;							//RTC Register No.2
	while(IIC2.ICSR.BIT.TEND == 0){}		//Wait for TEND
	IIC2.ICSR.BIT.TEND = 0;					//TEND=0
	IIC2.ICSR.BIT.STOP = 0;					//STOP=0
	dummy = IIC2.ICCR2.BYTE & 0x3f;			//BBSY=0,SCP=0(~)
	IIC2.ICCR2.BYTE = dummy;
	while(IIC2.ICSR.BIT.STOP == 0){}		//Wait for STOP
	dummy = IIC2.ICCR1.BYTE & 0xcf;			//MST=0,TRS=0
	IIC2.ICCR1.BYTE = dummy;
	IIC2.ICSR.BIT.TDRE = 0;					//TDRE=0

	Timer(1);

											//Aǂݏo(R2`R8)
											//            s,m,h,W,D,M,Y
	while(IIC2.ICCR2.BIT.BBSY != 0){}		//Wait for I2CBUS ready	
	IIC2.ICCR1.BYTE |= 0x30;				//MST=1,TRS=1 (Master TX mode)
	dummy = IIC2.ICCR2.BYTE & 0x3f;
	IIC2.ICCR2.BYTE = dummy | 0x80;			//BBSY=1,SCP=0(Jn)

			
	IIC2.ICDRT = 0xa3;						//TX SLA+R(1)
	while(IIC2.ICSR.BIT.TEND == 0){}		//Wait for TEND
	if(IIC2.ICIER.BIT.ACKBR != 0){goto RTC_NG;}

	set_imask_ccr(1);						//IRQ disable
	IIC2.ICSR.BIT.TEND = 0;
	IIC2.ICCR1.BIT.TRS = 0;					//TRS=0(Master RX mode)
	IIC2.ICSR.BIT.TDRE = 0;
	IIC2.ICIER.BIT.ACKBT = 0;
	dummy = IIC2.ICDRR;						//dummy read
	set_imask_ccr(0);						//IRQ enable

	for(i=0; i<7; i++){
		while(IIC2.ICSR.BIT.RDRF == 0){}	//Wait for RX
		I2CBUF[i] = IIC2.ICDRR;				//RX data
	}
	IIC2.ICIER.BIT.ACKBT = 1;
	IIC2.ICCR1.BIT.RCVD = 1;
	while(IIC2.ICSR.BIT.RDRF == 0){}		//Wait for RX

	IIC2.ICSR.BIT.STOP = 0;
	dummy = IIC2.ICCR2.BYTE & 0x3f;			//BBSY=0,SCP=0(~)
	IIC2.ICCR2.BYTE = dummy;
	while(IIC2.ICSR.BIT.STOP == 0){}		//Wait for STOP
	I2CBUF[i+1] = IIC2.ICDRR;				//Last data	
	IIC2.ICCR1.BIT.RCVD = 0;
	IIC2.ICCR1.BIT.MST = 0;

	return;


RTC_NG:
	IIC2.ICSR.BIT.TEND = 0;
	IIC2.ICSR.BIT.STOP = 0;
	IIC2.ICCR2.BYTE &= 0x3f;				//BBSY=0,SCP=0(~)
	while(IIC2.ICSR.BIT.STOP == 0){}	

	IIC2.ICCR1.BIT.MST = 0;
	IIC2.ICCR1.BIT.TRS = 0;
	IIC2.ICSR.BIT.TDRE = 0;

}




void RTC_WR(void){							//write RTC

volatile unsigned int i;
volatile unsigned char dummy;

	if((IO.PDR5.BYTE & 0xc0) != 0xc0){return;}		//P56,P57 Dip SW off ?


	while(IIC2.ICCR2.BIT.BBSY != 0){}		//Wait for I2CBUS ready
	IIC2.ICCR1.BYTE |= 0x30;				//MST=1,TRS=1(Master TX mode)
	dummy = IIC2.ICCR2.BYTE & 0x30;
	IIC2.ICCR2.BYTE = dummy | 0x80;			//BSSY=1,SCP=0(Jn)
	IIC2.ICDRT = 0xa2;						//TX SLA+W(0)
	while(IIC2.ICSR.BIT.TEND == 0){}
	if(IIC2.ICIER.BIT.ACKBR == 1){goto NG_RTC;}
	
	IIC2.ICDRT = 2;							//TX RTC Register No.=2
	while(IIC2.ICSR.BIT.TDRE == 0){}
	for(i=0; i<6; i++){
		IIC2.ICDRT = I2CBUF[i];				//TX data
		while(IIC2.ICSR.BIT.TDRE == 0){}
	}
	IIC2.ICDRT = I2CBUF[i];					//TX Last data	
	while(IIC2.ICSR.BIT.TEND == 0){}
	
NG_RTC:
	IIC2.ICSR.BIT.TEND = 0;
	IIC2.ICSR.BIT.STOP = 0;
	dummy = IIC2.ICCR2.BYTE & 0x3f;			//BBSY=0,SCP=0(~)
	IIC2.ICCR2.BYTE = dummy;
	while(IIC2.ICSR.BIT.STOP == 0){}	

	IIC2.ICCR1.BIT.MST = 0;
	IIC2.ICCR1.BIT.TRS = 0;
	IIC2.ICSR.BIT.TDRE = 0;

}




void LCD_CTRL(unsigned char CTRL){			//Ctrl(RS=0,R/W=0)

	IO.PDR8.BYTE = CTRL & 0xf0;				//High 4bit,RS=0,E=0
	IO.PDR8.BIT.B0 = 1;						//E=1
	IO.PDR8.BIT.B0 = 0;						//E=0
	IO.PDR8.BYTE = (CTRL * 16) & 0xf0;		//Low 4bit,RS=0,E=0
	IO.PDR8.BIT.B0 = 1;						//E=1
	IO.PDR8.BIT.B0 = 0;						//E=0
	Timer(2);
}



void LCD_DATA(unsigned char DATA){			//Data(RS=1,R/W=0)

	IO.PDR8.BYTE = (DATA & 0xf0) | 0x08;			//High 4bit,RS=1,E=0
	IO.PDR8.BIT.B0 = 1;						//E=1
	IO.PDR8.BIT.B0 = 0;						//E=0
	IO.PDR8.BYTE = ((DATA * 16) & 0xf0) | 0x08;		//Low 4bit,RS=1,E=0
	IO.PDR8.BIT.B0 = 1;						//E=1
	IO.PDR8.BIT.B0 = 0;						//E=0
	Timer(2);
}



void LCD_DISP(unsigned char *LCD_POINTER){

unsigned int i;

	LCD_CTRL(0x01);							//Disp.clear

	LCD_CTRL(0x80);							//1s1
	for(i=0; i<16; i++){
		if(*LCD_POINTER == 0x0d){
			return;
			break;
		}
		else{
			LCD_DATA(*LCD_POINTER);
			LCD_POINTER++;
		}
	}
	LCD_CTRL(0xc0);							//2s1
	for(i=0; i<16; i++){
		if(*LCD_POINTER == 0x0d){
			return;
			break;
		}
		else{
			LCD_DATA(*LCD_POINTER);
			LCD_POINTER++;
		}
	}
}



void LCD_INIT(void){

unsigned char LCD_CHR[] = "H8/3694-USB       °ٺ޳ M.Ota";
unsigned char *LCD_pointer;

	
	IO.PDR8.BYTE = 0x30;					//Function set(8bit) No.1 in 8bit mode
	IO.PDR8.BIT.B0 = 1;						//E=1
	IO.PDR8.BIT.B0 = 0;						//E=0
	Timer(2);
	IO.PDR8.BYTE = 0x30;					//Function set(8bit) No.2 in 8bit mode
	IO.PDR8.BIT.B0 = 1;						//E=1
	IO.PDR8.BIT.B0 = 0;						//E=0
	Timer(2);

	LCD_CTRL(0x28);							//Function set(4bit,2s,5x7dot) No.1
	LCD_CTRL(0x28);							//Function set(4bit,2s,5x7dot) No.2
	LCD_CTRL(0x0e);							//Disp.Ctrl(Disp.ON, Coursol.ON, Blink)
	LCD_CTRL(0x06);							//Goto Disp.mode
	LCD_CTRL(0x01);							//Disp.Clear

	LCD_pointer = LCD_CHR;
	LCD_DISP(LCD_pointer);
	
}



void LCD(void){

unsigned char *p;

	p = &RXBUF[3];
	LCD_DISP(p);

	Timer(10);								//TX Resp. to PC
	TX1RS(0x3a);							//":"
	TX1RS(0x4c);							//"L"
	TX1RS(0x0d);							//CR
}



void OUTPORT(void){

unsigned char dummy,*p;

	p = &RXBUF[3];
	dummy = HEX2_BIN(p);					//s_
	IO.PDR1.BYTE = ~ dummy;
	Timer(10);
											// TX Resp. to PC
	TX1RS(0x3a);							//":"
	TX1RS(0x4f);							//"O"
	TX1RS(0x0d);							//CR

}



void PWM_A(void){

unsigned char dummy,*p;

	p = &RXBUF[3];
	dummy = HEX2_BIN(p);
	TV.TCORA = dummy;						//Set PWM Duty
	Timer(10);

	TX1RS(0x3a);							//":"
	TX1RS(0x41);							//"A"
	TX1RS(0x0d);							//CR

}



void PWM_B(void){

unsigned char dummy,*p;

	p = &RXBUF[3];
	dummy = HEX2_BIN(p);
	TV.TCORB = dummy;						//Set PWM Period
	Timer(10);

	TX1RS(0x3a);							//":"
	TX1RS(0x42);							//"B"
	TX1RS(0x0d);							//CR

}



void CLOCK_SET(void){
	
	I2CBUF[6] = HEX2_BCD(&RXBUF[3]);		//YY
	I2CBUF[5] = HEX2_BCD(&RXBUF[5]);		//MM
	I2CBUF[4] = 0;	
	I2CBUF[3] = HEX2_BCD(&RXBUF[7]);		//DD
	
	I2CBUF[2] = HEX2_BCD(&RXBUF[10]);		//hh	
	I2CBUF[1] = HEX2_BCD(&RXBUF[12]);		//mm	
	I2CBUF[0] = HEX2_BCD(&RXBUF[14]);		//ss	

	RTC_WR();
	Timer(10);

	TX1RS(0x3a);							//":"
	TX1RS(0x43);							//"C"
	TX1RS(0x0d);							//CR		
}



void READ(void){

unsigned int dummy;
											
	Timer(10);

	TX1RS(0x3a);							//":"
	TX1RS(0x52);							//"R"
	TX1RS(0x20);							//" "
	
	TX1HEX(~ IO.PDR1.BYTE);					//OUTPORT(P1)_
	TX1RS(0x20);							//" "
	
	TX1HEX(~ IO.PDR5.BYTE);					//INPORT(P5)_
	TX1RS(0x20);							//" "

	TX2HEX(WIDTH);							//GRB
	TX1RS(0x20);

	TX2HEX(PERIOD);							//GRA
	TX1RS(0x20);

	AD_START();
	AD.ADCSR.BIT.CH = 0;					//AN0
	dummy = AD.ADDRA / 64;					//El
	TX2HEX(dummy);
	TX1RS(0x20);
	AD.ADCSR.BIT.CH = 1;					//AN1
	dummy = AD.ADDRB / 64;					//El
	TX2HEX(dummy);
	TX1RS(0x20);
	AD.ADCSR.BIT.CH = 2;					//AN2
	dummy = AD.ADDRC / 64;					//El
	TX2HEX(dummy);
	TX1RS(0x20);
	AD.ADCSR.BIT.CH = 3;					//AN3
	dummy = AD.ADDRD / 64;					//El
	TX2HEX(dummy);
	TX1RS(0x20);

	RTC_RD();
	TX1HEX(I2CBUF[6]);						//YY
	TX1HEX(I2CBUF[5] & 0x1f);				//MM
	TX1HEX(I2CBUF[3] & 0x3f);				//DD
	TX1RS(0x20);							//" "
	TX1HEX(I2CBUF[2] & 0x3f);				//hh
	TX1HEX(I2CBUF[1]);						//mm
	TX1HEX(I2CBUF[0]);						//ss

	TX1RS(0x0d);							//CR
}



void INITIALIZE(void){

	unsigned char dummy;

	Timer(10);
	
											//(I2C)
	IIC2.ICCR1.BYTE = 0x82;					//CLK=417KHz
	IIC2.ICCR2.BYTE = 0x00;	
	IIC2.ICMR.BYTE = 0x40;					//MSB first, Wait, 9bit
	IIC2.SAR.BYTE =	0x00;
	IIC2.ICCR2.BIT.IICRST = 1;				//IICRST=1(I2C Reset)
	Timer(1);
	IIC2.ICCR2.BIT.IICRST = 0;				//IICRST=0
	
											//(I/O PORT)
	IO.PCR1 = 0xf7;							//P1 output
	IO.PUCR5.BYTE = 0x3f;					//P5 pull up
	IO.PCR7 = 0x20;							//P7 output
	IO.PCR8 = 0xf9;							//P8 output(for LCD)

											//(A/D Converter)
	AD.ADCR.BYTE = 0;						//AD trig.non
	AD.ADCSR.BYTE = 0x13;					//Scan mode 0~3
	AD_START();								//dummy

											//(TimerA)
	TA.TMA.BYTE = 0x89;						//TMOV=W/32, W, 0.5S
	IENR1.BIT.IENTA = 1;					//TimerA IRQ enable
	IRR1.BIT.IRRTA = 0;

											//(TimerV = PWM)
	TV.TCRV0.BYTE = 0x13;					//Clear V at CMFB
	TV.TCRV1.BYTE = 0x01;					//CLK=/128
	TV.TCSRV.BYTE = 0x09;					//CMFA0, CMFB1
	TV.TCORB = 255;							//init Period
	TV.TCORA = 127;							//init Duty 50%

											//(Timer W = Input Capture)
	TW.TMRW.BYTE = 0;						//Timer W stop
	TW.TCRW.BYTE = 0x10;					//                 CLK=/2
	TW.TIERW.BYTE = 0x03;					//IRQ enable by IMFB,IMFA
	TW.TIOR0.BYTE = 0x54;					//GRB, GRA
	TW.TCNT = 0;							//clear TimerW
	TW.TSRW.BYTE = 0;						//cear Flag
	TW.TMRW.BYTE = 0x80;					//TimerW start
	
											//(SCI3)
	SCI3.SMR.BYTE = 0;
	SCI3.SCR3.BYTE = 0;						//8-N-1
	SCI3.BRR = 32;							//19200bps
	Timer(1);
	dummy = SCI3.RDR;
	SCI3.SCR3.BYTE = 0x70;					//RX IRQ enable
	SCI3.SSR.BYTE = 0x80;
	IO.PMR1.BIT.TXD = 1;					//P22=TXD
	Timer(1);
	dummy = SCI3.SSR.BYTE;
	dummy = SCI3.RDR;
	
	
	LCD_INIT();

}






void main(void){

	set_imask_ccr(1);							//IRQ disable
	INITIALIZE();
	set_imask_ccr(0);							//IRQ enable
		
	IO.PDR1.BYTE = IO.PDR5.BYTE;				//P5P1

Loop:
	RXBUF_CLR();
	while(CR_FLAG != 0x0d){}					//RX CR code ?
	if(RXBUF[0] != 0x2a){goto Loop;}			//"*" ?

	switch(RXBUF[1]){

		case 0x52:								//"R" command ?
			if(RXBUF[2] != 0x0d){goto Loop;}
			READ();
			break;

		case 0x4f:								//"O" command ?
			if(RXBUF[5] != 0x0d){goto Loop;}
			OUTPORT();
			break;

		case 0x41:								//"A" command ?
			if(RXBUF[5] != 0x0d){goto Loop;}
			PWM_A();
			break;

		case 0x42:								//"B" command ?
			if(RXBUF[5] != 0x0d){goto Loop;}
			PWM_B();
			break;

		case 0x4c:								//"L" command ?
			LCD();
			break;

		case 0x43:								//"C" command ?
			if(RXBUF[16] != 0x0d){goto Loop;}
			CLOCK_SET();
			break;
	}
	goto Loop;
}





#ifdef __cplusplus
void abort(void)
{
	
}
#endif
